package com.thebrokenrail.sorcerycraft.spell;

import net.minecraft.entity.Entity;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Items;

public class FlameSpell extends Spell {
    public FlameSpell(String id, int level) {
        super(id, level);
    }

    @Override
    public void execute(Entity target, Entity source, Entity attacker) {
        target.setFireTicks(400 + (getLevel() * 200));
    }

    @Override
    public int getXPCost() {
        switch (getLevel()) {
            case 0: {
                return 8;
            }
            case 1: {
                return 16;
            }
        }
        return -1;
    }

    @Override
    public ItemStack getItemCost() {
        switch (getLevel()) {
            case 0: {
                return new ItemStack(Items.FLINT_AND_STEEL);
            }
            case 1: {
                return new ItemStack(Items.FIRE_CHARGE);
            }
        }
        return ItemStack.EMPTY;
    }

    @Override
    public int getMaxLevel() {
        return 2;
    }
}
